%define major 1
%define libname %mklibname %{name} %{major}
%define devname %mklibname %{name} -d
%define sdevname %mklibname %{name} -d -s

%bcond_with bootstrap

Summary:	JPEG-2000 utilities
Name:		jasper
Version:	1.900.1
Release:	20
License:	BSD-like
Group:		Graphics
Url:		http://www.ece.uvic.ca/~mdadams/jasper/
Source0: 	http://www.ece.uvic.ca/~mdadams/jasper/software/%{name}-%{version}.zip
Patch1:		jasper-1.701.0-GL.patch
# autoconf/automake bits of patch1
Patch2:		jasper-1.701.0-GL-ac.patch
# CVE-2007-2721 (bug #240397)
# borrowed from http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=413041;msg=88
Patch3:		patch-libjasper-stepsizes-overflow.diff
# borrowed from http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=469786 
Patch4:		jpc_dec.c.patch
# OpenBSD hardening patches addressing couple of possible integer overflows
# during the memory allocations
# https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2008-3520
Patch5:		jasper-1.900.1-CVE-2008-3520.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2008-3522
Patch6:		jasper-1.900.1-CVE-2008-3522.patch
# add pkg-config support
Patch7:		jasper-pkgconfig.patch
Patch8:		jasper-1.900.1-CVE-2011-4516-CVE-2011-4517-CERT-VU-887409.patch
# Issues found by static analysis of code
Patch10:	jasper-1.900.1-Coverity-BAD_SIZEOF.patch
Patch11:	jasper-1.900.1-Coverity-CHECKED_RETURN.patch
Patch12:	jasper-1.900.1-Coverity-FORWARD_NULL.patch
Patch13:	jasper-1.900.1-Coverity-NULL_RETURNS.patch
Patch14:	jasper-1.900.1-Coverity-RESOURCE_LEAK.patch
Patch15:	jasper-1.900.1-Coverity-UNREACHABLE.patch
Patch16:	jasper-1.900.1-Coverity-UNUSED_VALUE.patch

Patch19: jasper-1.900.1-CVE-2014-9029.patch
Patch20: jasper-1.900.1-CVE-2014-8137.patch
Patch21: jasper-1.900.1-CVE-2014-8138.patch
Patch22: jasper-1.900.1-CVE-2014-8157.patch
Patch23: jasper-1.900.1-CVE-2014-8158.patch
Patch25: jasper-1.900.1-CVE-2016-1867.patch
Patch26: jasper-1.900.1-CVE-2016-2089.patch
Patch27: jasper-1.900.1-CVE-2016-1577.patch
Patch28: jasper-1.900.1-CVE-2016-2116.patch
Patch29: jasper-CVE-2015-5221.patch

BuildRequires:	jpeg-devel
%if %{without bootstrap}
BuildRequires:	pkgconfig(glut)
%endif

%description
JasPer is a software-based implementation of the codec specified in the
emerging JPEG-2000 Part-1 standard (i.e., ISO/IEC 15444-1).  This package
contains tools for working with JPEG-2000 images.

%files
%doc README LICENSE NEWS
%{_bindir}/imgcmp
%{_bindir}/imginfo
%{_bindir}/jasper
%if %{without bootstrap}
%{_bindir}/jiv
%endif
%{_bindir}/tmrdemo
%{_mandir}/man1/imgcmp.1*
%{_mandir}/man1/imginfo.1*
%{_mandir}/man1/jasper.1*
%{_mandir}/man1/jiv.1*

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Shared library for JasPer
Group:		System/Libraries

%description -n %{libname}
JasPer is a software-based implementation of the codec specified in the
emerging JPEG-2000 Part-1 standard (i.e., ISO/IEC 15444-1). This package
contains shared library for working with JPEG-2000 images.

%files -n %{libname}
%{_libdir}/libjasper.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development tools for programs which will use the libjasper library
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}
Provides:	lib%{name}-devel = %{EVRD}

%description -n %{devname}
This package includes the header files necessary for developing programs which
will manipulate JPEG-2000 files using the libjasper library.

%files -n %{devname}
%doc doc/README.pdf doc/jasper.pdf doc/jpeg2000.pdf 
%dir %{_includedir}/%{name}
%dir %{multiarch_includedir}/%{name}
%{multiarch_includedir}/%{name}/*.h
%{_includedir}/%{name}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/jasper.pc

#----------------------------------------------------------------------------

%package -n %{sdevname}
Summary:	Static libraries for programs which will use the libjasper library
Group:		Development/C
Requires:	%{devname} = %{EVRD}
Provides:	%{name}-static-devel = %{EVRD}

%description -n %{sdevname}
This package includes the static libraries necessary for developing programs
which will manipulate JPEG-2000 files using the libjasper library.

%files -n %{sdevname}
%{_libdir}/*.a

#----------------------------------------------------------------------------

%prep
%setup -q
%patch1 -p1 -b .GL
%patch2 -p1 -b .GL-ac
%patch3 -p1 -b .CVE-2007-2721
%patch4 -p1 -b .jpc_dec_assertion
%patch5 -p1 -b .CVE-2008-3520
%patch6 -p1 -b .CVE-2008-3522
%patch7 -p1 -b .pkgconfig
%patch8 -p1 -b .CVE-2011-4516-4517

%patch10 -p1 -b .BAD_SIZEOF
%patch11 -p1 -b .CHECKED_RETURN
%patch12 -p1 -b .FORWARD_NULL
%patch13 -p1 -b .NULL_RETURNS
%patch14 -p1 -b .RESOURCE_LEAK
%patch15 -p1 -b .UNREACHABLE
%patch16 -p1 -b .UNUSED_VALUE

%patch19 -p1 -b .CVE-2014-9029
%patch20 -p1 -b .CVE-2014-8137
%patch21 -p1 -b .CVE-2014-8138
%patch22 -p1 -b .CVE-2014-8157
%patch23 -p1 -b .CVE-2014-8158
%patch25 -p1 -b .CVE-2016-1867
%patch26 -p1 -b .CVE-2016-2089
%patch27 -p1 -b .CVE-2016-1577
%patch28 -p1 -b .CVE-2016-2116
%patch29 -p1 -b .CVE-2015-5221

mv doc/README doc/README.pdf

%build
autoreconf -fi

%configure2_5x --enable-shared

%make

%install
%makeinstall_std

%multiarch_includes %{buildroot}%{_includedir}/jasper/jas_config.h


%changelog

* Tue Sep 20 2016 Denis Silakov <denis.silakov@rosalab.ru> 1.900.1-20
- (309b986) Fix CVE-2015-5221


